Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr20.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr20.java	(revision 4809)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr20.java	(working copy)
@@ -49,7 +49,7 @@
 	public void buildFromStreets(List<Mdr7Record> inStreets) {
 		ArrayList<Mdr7Record> sorted = new ArrayList<>(inStreets);
 		sorted.sort((o1, o2) -> {
-			int d = Integer.compare(o1.getCity().getMdr20SortPos(), o2.getCity().getMdr20SortPos());
+			int d = Integer.compare(o1.getCity().getMdr20Index(), o2.getCity().getMdr20Index());
 			if (d != 0)
 				return d;
 			return Integer.compare(o1.getIndex(), o2.getIndex());
@@ -65,7 +65,7 @@
 		
 		for (Mdr7Record street : sorted) {
 			Mdr5Record city = street.getCity();
-			boolean citySameByName = lastCity != null && city.getMdr20SortPos() == lastCity.getMdr20SortPos();
+			boolean citySameByName = lastCity != null && city.getMdr20Index() == lastCity.getMdr20Index();
 			int rr = street.checkRepeat(lastStreet, collator);
 			// Only save a single copy of each street name.
 			if (!citySameByName || rr != 3 || lastStreet.getIndex() != street.getIndex()) {
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr5.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr5.java	(revision 4810)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr5.java	(working copy)
@@ -65,7 +65,6 @@
 		Sort sort = getConfig().getSort();
 		genCitiesAndMdr20s(sort);
 		// calculate positions for the different road indexes
-		calcMdr20SortPos(sort);
 		calcMdr21SortPos(sort);
 		calcMdr22SortPos(sort);
 	}
@@ -120,39 +119,6 @@
 	}
 
 	/**
-	 * Calculate a position when sorting by name, region, and country- This is used for MDR20. 
-	 */
-	private void calcMdr20SortPos(Sort sort) {
-		List<SortKey<Mdr5Record>> sortKeys = new ArrayList<>(allCities.size());
-		Map<String, byte[]> regionCache = new HashMap<>();
-		Map<String, byte[]> countryCache = new HashMap<>();
-		for (Mdr5Record m : allCities) {
-			if (m.getName() == null)
-				continue;
-
-			// Sort by city name, region name, and country name .
-			SortKey<Mdr5Record> sortKey = sort.createSortKey(m, m.getName());
-			SortKey<Mdr5Record> regionKey = sort.createSortKey(null, m.getRegionName(), 0, regionCache);
-			SortKey<Mdr5Record> countryKey = sort.createSortKey(null, m.getCountryName(), 0, countryCache);
-			sortKey = new MultiSortKey<>(sortKey, regionKey, countryKey);
-			sortKeys.add(sortKey);
-		}
-		regionCache = null;
-		countryCache = null;
-		sortKeys.sort(null);
-
-		SortKey<Mdr5Record> lastKey = null;
-		int pos = 0;
-		for (SortKey<Mdr5Record> key : sortKeys) {
-			Mdr5Record c = key.getObject();
-			if (lastKey == null || key.compareTo(lastKey) != 0)
-				pos++;
-			c.setMdr20SortPos(pos);
-			lastKey = key;
-		}
-	}
-
-	/**
 	 * Calculate a position when sorting by region- This is used for MDR21. 
 	 */
 	private void calcMdr21SortPos(Sort sort) {
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr5Record.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr5Record.java	(revision 4809)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr5Record.java	(working copy)
@@ -36,7 +36,6 @@
 	private Mdr14Record country;
 	private int[] mdr20;
 	private int mdr20Index;
-	private int mdr20SortPos;
 	private int mdr21SortPos;
 	private int mdr22SortPos;
 
@@ -125,6 +124,10 @@
 		this.mdr20Index = mdr20Index;
 	}
 
+	public int getMdr20Index() {
+		return mdr20Index;
+	}
+
 	public int getMdr20() {
 		return mdr20[mdr20Index];
 	}
@@ -178,13 +181,6 @@
 		return country.getName();
 	}
 
-	public void setMdr20SortPos(int n) {
-		mdr20SortPos = n;
-	}
-
-	public int getMdr20SortPos() {
-		return mdr20SortPos;
-	}
 	public void setMdr21SortPos(int n) {
 		mdr21SortPos = n;
 	}
